/*
 * Copyright 2020 Mamoe Technologies and contributors.
 *
 * 此源代码的使用受 GNU AFFERO GENERAL PUBLIC LICENSE version 3 许可证的约束, 可以在以下链接找到该许可证.
 * Use of this source code is governed by the GNU AGPLv3 license that can be found through the following link.
 *
 * https://github.com/mamoe/mirai/blob/master/LICENSE
 *
 */

package net.mamoe.mirai.console.pure

import org.jline.reader.LineReader
import org.jline.reader.LineReaderBuilder
import org.jline.reader.impl.completer.NullCompleter
import org.jline.terminal.Terminal
import org.jline.terminal.TerminalBuilder

object ConsoleUtils {

    val lineReader: LineReader
    val terminal: Terminal

    init {

        val dumb = System.getProperty("java.class.path")
            .contains("idea_rt.jar") || System.getProperty("mirai.idea") !== null

        terminal = TerminalBuilder.builder()
            .dumb(dumb)
            .build()
        lineReader = LineReaderBuilder.builder()
            .terminal(terminal)
            .completer(NullCompleter())
            .build()
    }
}